--Ktantan, encryption
--function "round counter LFSR"

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY round_count IS
  PORT(
    mode_i  : IN STD_LOGIC;
    T_in    : IN STD_LOGIC_VECTOR(7 DOWNTO 0);     --T input, before changes
    T_out   : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)     --T output, after changes
    );
END round_count;

ARCHITECTURE rtl OF round_count IS

BEGIN
  
  with mode_i select
    T_out <=
      T_in(6 downto 0) & (T_in(7) XOR T_in(6) XOR T_in(4) XOR T_in(2)) when '0',
      (T_in(0) XOR T_in(7) XOR T_in(5) XOR T_in(3)) & T_in(7 DOWNTO 1) when others;

END rtl;
