--Ktantan, encryption
--function Fa

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY function_fa IS
  PORT(
    mode_i   : IN STD_LOGIC;                     --mode
    L1       : IN STD_LOGIC_VECTOR(24 DOWNTO 0); --register L1
    L2_i     : IN STD_LOGIC_VECTOR(2 DOWNTO 0);  --LSB of L2
    IR       : IN STD_LOGIC;                     --irregular rule
    k        : IN STD_LOGIC;                     --subkey bit ka
    fa_out   : OUT STD_LOGIC
    );
END function_fa;

ARCHITECTURE rtl OF function_fa IS
  
BEGIN

--conditionnal assigment
  WITH mode_i SELECT  
    fa_out <= L1(22) XOR L1(13) XOR (L1(18) AND L1(9)) XOR (L1(7) AND IR) XOR k WHEN '0',
              L2_i(0) XOR L1(16) XOR (L1(21) AND L1(12)) XOR (L1(10) AND IR) XOR k WHEN OTHERS;

END rtl;

    
