--Ktantan, encryption
--function Fb

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY function_fb IS
  PORT(
    mode_i : IN STD_LOGIC;                     --mode
    L2     : IN STD_LOGIC_VECTOR(38 DOWNTO 0); --register L2
    L1_i   : IN STD_LOGIC_VECTOR(2 DOWNTO 0);                     --LSB of L1
    k      : IN STD_LOGIC;                     --subkey bit kb
    fb_out : OUT STD_LOGIC
    );
END function_fb;

ARCHITECTURE rtl OF function_fb IS
  
BEGIN

--selectrive assigment
  WITH mode_i SELECT
    fb_out <= L2(36) XOR L2(23) XOR (L2(31) AND L2(19)) XOR (L2(12) AND L2(7)) XOR k WHEN '0',
              L1_i(0) XOR L2(26) XOR (L2(34) AND L2(22)) XOR (L2(15) AND L2(10)) XOR k WHEN OTHERS;

END rtl;

    
